#include "Energia.h"

#line 1 "C:/Users/Xavi/workspace_v7/MotorController-viaWebServerWiFi_v4/MotorController-viaWebServerWiFi_v3.1.ino"


















#ifndef __CC3200R1M1RGC__
#include <SPI.h>
#endif
#include <WiFi.h>
#include <WiFiClient.h>
#include <Wire.h>
#include <Stdio.h>
#include "SCMD.h"
#include "HCSR04.h"
#include "configWIFI.h"
#include "configHardware.h"
#include "configSys.h"

void setup();
void loop();
boolean endsWith(char* inString, const char* compString);
void printWifiStatus();
int ScanNetworks(void);
void leftClash (void);
void rightClash (void);
void wifiConnect(void);
void sendNetworks(void);
void sendRSSI(void);
int readSessionId(void);
int detNumberPositions(void);
void sendPosAvailable(void);
void avoidCollision(void);

#line 32
volatile bool lContact = false;    
volatile bool rContact = false;     

long distToObst;    

int keyIndex = 0;

SCMD mySCMD;
HCSR04 myDistSensor;

WiFiServer server(myPort);



struct ListNetArray{     
    int Id;
    char SSID[32];
};

struct ListRSSIArray{    
    int Id;
    int32_t RSSI;
};

ListNetArray ListOfNetworks[numNetwork] {};        
ListRSSIArray actualRSSInetworks[numNetwork] {};  

int idSession;      
int idPosition;      
int posAvai=0;        

WiFiClient client;   
IPAddress ip(AWSR_IPaddress); 


extern char ssid[] = mySSID;          
extern char password[] = myPassword;   


extern uint16_t port = myPort;     
extern IPAddress serverObj(myIPaddress);   



void setup() {

  
  Serial.begin(serialBaudRate);     
  pinMode(onLED, OUTPUT);      
  pinMode(leftContLED, INPUT);       
  pinMode(rightContLED, INPUT);       
  pinMode(trigPin, OUTPUT); 
  pinMode(echoPin, INPUT);  

  
  attachInterrupt(leftContactPIN,leftClash,FALLING);    
  attachInterrupt(rightContactPIN,rightClash,FALLING);    


  Wire.setModule(0);
  Wire.begin(addressI2C);     
  mySCMD.reset();       
  
  wifiConnect();        

  
   Wire.beginTransmission(addressI2C);
   Wire.write(0x70);
   Wire.write(0x01);
   Wire.endTransmission();
}


void loop() {
  int i = 0;
  WiFiClient client = server.available();   
  distToObst=myDistSensor.distObstacle();    

  

  if (client) {                             
    Serial.println("new client");           
    char buffer[150] = {0};                 
    while (client.connected()) {            
      if (client.available()) {             
        char c = client.read();             
        Serial.write(c);                    
        if (c == '\n') {                    

          
          
          if (strlen(buffer) == 0) {
            
            
            client.println("HTTP/1.1 200 OK");
            client.println("Content-type:text/html");
            client.println();

            
            client.println("<html><head><title>Motor Controller</title></head><body align=center>");
            client.println("<h1 align=center><font color=\"red\">Welcome to the AUTONOMOUS WIFI SCANNER ROBOT Server</font></h1>");
            client.print("START SCANNING <button onclick=\"location.href='/T'\">START</button>");
            client.println(" <button onclick=\"location.href='/S'\">STOP</button><br>");

            
            int NumNetworks=ScanNetworks();   
            if (NumNetworks==-1) {              
                client.println("Couldn't get a wifi connection");  
                while (true);
           }

            
            client.println();
            
            break;
          }
          else {      
            memset(buffer, 0, 150);
            i = 0;
          }
        }
        else if (c != '\r') {    
          buffer[i++] = c;      
        }

        
        if (endsWith(buffer, "GET /T")) {       
          client.println("<br>** Scanning Networks **");
          digitalWrite(onLED, HIGH);               
          idSession=readSessionId();            

          int totalPos=detNumberPositions();    
          int lastTurn=0;                       

          idPosition=0;                         
          ScanNetworks();                      
          sendNetworks();                       
          sendRSSI();                           
          sendPosAvailable();                  

              
              distToObst=myDistSensor.distObstacle();    
              Serial.println("distance:");
              Serial.print(distToObst);
              Serial.println(" cm");
              while (idPosition<=totalPos) {
                  mySCMD.reset();       
                  if (lContact==true || rContact==true) {   
                      lContact=false;                       
                      rContact=false;                       
                      sendPosAvailable();                  
                  }

                  if (lContact==false || rContact==false) {   
                      posAvai=0;                           
                  }
                  while (myDistSensor.distObstacle() < 40 && lastTurn==0)  {
                          mySCMD.moveMotors (RIGHT);                   
                          delay(1000);                         
                          mySCMD.moveMotors (STOP);                   
                          delay(1000);
                          posAvai=1;                           
                          idPosition++;                         
                          sendPosAvailable();                  
                          if (myDistSensor.distObstacle() >= 30) {              
                              lastTurn=1;                       
                              mySCMD.moveMotors (RIGHT);                   
                              delay(1000);                         
                              mySCMD.moveMotors (STOP);                   
                          }
                  }
                  while (myDistSensor.distObstacle() < 40 && lastTurn==1) {
                          mySCMD.moveMotors (LEFT);                   
                          delay(1000);                         
                          mySCMD.moveMotors (STOP);                   
                          delay(1000);
                          posAvai=1;                           
                          idPosition++;                         
                          sendPosAvailable();                  
                          if (myDistSensor.distObstacle() >= 30) {              
                              lastTurn=0;                       
                              mySCMD.moveMotors (LEFT);                   
                              delay(1000);                         
                              mySCMD.moveMotors (STOP);                   
                          }
                  }
                  distToObst=myDistSensor.distObstacle();    
                  if (distToObst>20) {                  
                      posAvai=0;                           
                  }
                  idPosition++;                         
                  ScanNetworks();                      
                  sendNetworks();                       
                  sendRSSI();                           
                  sendPosAvailable();                  

                  mySCMD.moveMotors (FORWARD);                
                  delay(1000);                         
                  mySCMD.moveMotors (STOP);                   

                  Serial.println("distance:");              
                  Serial.print(distToObst);
                  Serial.println(" cm");

                  if (distToObst >= 200 || distToObst <= 0){
                      Serial.println("Out of range");
                      mySCMD.moveMotors (STOP);                   
                      for (int k=0; k<20;k++) {                   
                          digitalWrite(onLED, LOW);               
                          delay(500);                             
                          digitalWrite(onLED, HIGH);               
                      }
                  }
                  else {
                      Serial.print(distToObst);         
                      Serial.println(" cm");
                  }
              }
        }

        if (endsWith(buffer, "GET /S")) {           
          digitalWrite(onLED, LOW);
          mySCMD.moveMotors (STOP);                   
        }
      }
    }
    
    client.stop();
    Serial.println("client disconnected");
  }
}






boolean endsWith(char* inString, const char* compString) {
  int compLength = strlen(compString);
  int strLength = strlen(inString);
  
  
  int i;
  for (i = 0; i < compLength; i++) {
    char a = inString[(strLength - 1) - i];
    char b = compString[(compLength - 1) - i];
    if (a != b) {
      return false;
    }
  }
  return true;
}



void printWifiStatus() {
  Serial.print("SSID: ");
  Serial.println(WiFi.SSID());  

  
  IPAddress ip = WiFi.localIP();
  Serial.print("IP Address: ");
  Serial.println(ip);

  
  long rssi = WiFi.RSSI();
  Serial.print("signal strength (RSSI):");
  Serial.print(rssi);
  Serial.println(" dBm");
  
  Serial.print("To see this page in action, open a browser to http://");
  Serial.println(ip);
}




int ScanNetworks(void){

      int numSsid = WiFi.scanNetworks();        
      if (numSsid == -1)                        
      {
        return numSsid;                         
        while (true);
      }
      int netPos=0;                             
      int RSSIpos=0;                            
      if (ListOfNetworks[0].Id==NULL) {                       
          for (int thisNet = 0; thisNet < numSsid; thisNet++) {
                  ListOfNetworks[thisNet].Id=thisNet+1;
                  strcpy(ListOfNetworks[thisNet].SSID, WiFi.SSID(thisNet));     
                  actualRSSInetworks[thisNet].Id=thisNet+1;                     
                  actualRSSInetworks[thisNet].RSSI=WiFi.RSSI(thisNet);          

                }
       }
      while (ListOfNetworks[netPos].Id!=NULL)  {                            

          for (int thisNet = 0; thisNet < numSsid; thisNet++) {             
              if (ListOfNetworks[netPos].SSID==WiFi.SSID(thisNet)) {        
                  actualRSSInetworks[RSSIpos].Id=ListOfNetworks[netPos].Id; 
                  actualRSSInetworks[RSSIpos].RSSI=WiFi.RSSI(thisNet);      
                  RSSIpos++;

              } else if (ListOfNetworks[netPos+1].Id==NULL && ListOfNetworks[netPos].SSID!=WiFi.SSID(thisNet)){ 
                   strcpy(ListOfNetworks[netPos+1].SSID, WiFi.SSID(thisNet));     
              }
          }
          netPos++;
      }

      return numSsid;

}


void leftClash (void){
    lContact=true;                              
    posAvai=1;                                  
    avoidCollision();                           
}


void rightClash (void){
    rContact=true;                              
    posAvai=1;                                  
    avoidCollision();                           

}



void wifiConnect(void) {
    
    Serial.print("Attempting to connect to Network named: ");
    
    Serial.println(ssid);
    
    WiFi.begin(ssid, password);
    while ( WiFi.status() != WL_CONNECTED) {
      
      Serial.print(".");
      delay(300);
    }

    Serial.println("\nYou're connected to the network");
    Serial.println("Waiting for an ip address");

    while (WiFi.localIP() == INADDR_NONE) {
      
      Serial.print(".");
      delay(300);
    }

    Serial.println("\nIP Address obtained");

    
    printWifiStatus();

    Serial.println("Starting webserver on port 80");
    server.begin();                           
    Serial.println("Webserver started!");
}


void sendNetworks(void){

    int i=0;
    String data;

    while (ListOfNetworks[i].Id!=NULL) {
        data="idExp=" + String(idSession) + "&idNetw=" + String(ListOfNetworks[i].Id) + "&netwName="+ListOfNetworks[i].SSID+"\0"; 
        Serial.println("data content:");
        Serial.println(data);


        Serial.println("Attempting to connect to server");  

        

        client.stop();      
                            

        if (client.connect(serverObj, port)) { 
                Serial.println("\nConnected to the server!");
                  client.println("POST /AWSR/addNewNetworks.php HTTP/1.1");     
                 client.print("Host: "); 
                 client.println(serverObj);
                 client.println("Content-Type: application/x-www-form-urlencoded"); 
                 client.print("Content-Length: ");                                  
                 client.println(data.length());
                 client.println();
                 client.println(data);


         } else { Serial.println("\nFailed when connecting to the server");}
         i++;
    }


    if (client.connected()) {
        client.stop();  
    }

}


void sendRSSI(void){

    int i=0;
    String data;

    while (actualRSSInetworks[i].Id!=NULL) {
        data="idExp=" + String(idSession) + "&idPos="+ String(idPosition) + "&idNetw="+ String(actualRSSInetworks[i].Id) + "&RSSI="+String(actualRSSInetworks[i].RSSI)+"\0"; 
        Serial.println("RSSI content:");
        Serial.println(data);
        
        
        Serial.println("Attempting to connect to server");

        

        
          
        client.stop();

        if (client.connect(serverObj, port)) { 
                Serial.println("\nConnected to the server!");
                  client.println("POST /AWSR/addPositionRSSI.php HTTP/1.1");        
                 client.print("Host: "); 
                 client.println(serverObj);
                 client.println("Content-Type: application/x-www-form-urlencoded"); 
                 client.print("Content-Length: ");                                  
                 client.println(data.length());
                 client.println();
                 client.println(data);


         } else { Serial.println("\nFailed when connecting to the server");}
         i++;
    }


    if (client.connected()) {
        client.stop();  
    }

}



int readSessionId(void) {
           client.stop();
           int idSes=0;
           char c[90];
           if (client.connect(serverObj, port)) { 
                   Serial.println("\nConnected to the server in function readSessionId!");
                    client.println("GET /AWSR/retrySessionID.php HTTP/1.1");
                    client.print("Host: "); 
                    client.println(serverObj);
                    client.print("Connection:close\r\n\r\n");
                    while (client.connected()) {            
                          if (client.available()) {             
                              for (int k=0; k<90;k++) {
                                  c[k+1] = client.read();
                                  Serial.print(c[k+1]);
                               }
                              Serial.print("session id received: ");
                              for (int k=0; k<90;k++) {
                                  if (c[k]=='i' && c[k+1]=='d' && c[k+2]=='E' && c[k+3]=='x' && c[k+4]=='p') {     
                                      if (c[k+8]==39) {                                                            
                                              idSes=c[k+7]-'0';                                                         
                                  } else if (c[k+9]==39){                                                           
                                              idSes=(c[k+7]-'0')*10 + (c[k+8]-'0');                                 
                                  } else if (c[k+10]==39){                                                          
                                              idSes=(c[k+7]-'0')*100 + (c[k+8]-'0')*10+(c[k+9]-'0');
                              }
                              }}
                              Serial.println(idSes);
                          }}
            } else { Serial.println("\nFailed when connecting to the server");}

           client.stop();
           return idSes;
}


int detNumberPositions(void) {
    int posX, posY, posTOT;                 
    posX=myDistSensor.distObstacle()/20;    
    mySCMD.moveMotors (RIGHT);                   
    delay(1000);                            
    mySCMD.moveMotors (STOP);                   
    posY=myDistSensor.distObstacle()/20;    
    mySCMD.moveMotors (LEFT);                   
    delay(1000);                            
    mySCMD.moveMotors (STOP);                   
    posTOT=posX*posY;                       
    return posTOT;
}



void sendPosAvailable(void){

    String data;

    
        data="idExp=" + String(idSession) + "&idPos="+ String(idPosition) + "&available="+ String(posAvai)+"\0"; 
        Serial.println("data content:");
        Serial.println(data);


        Serial.println("Attempting to connect to server");  

        

        client.stop();      
                            

        if (client.connect(serverObj, port)) { 
                Serial.println("\nConnected to the server!");
                  client.println("POST /AWSR/addPositionAva.php HTTP/1.1");         
                 client.print("Host: "); 
                 client.println(serverObj);
                 client.println("Content-Type: application/x-www-form-urlencoded"); 
                 client.print("Content-Length: ");                                  
                 client.println(data.length());
                 client.println();
                 client.println(data);


         } else { Serial.println("\nFailed when connecting to the server");}

    if (client.connected()) {
        client.stop();  
    }

}


void avoidCollision(void){
            mySCMD.moveMotors (STOP);                   
            mySCMD.moveMotors (BACKWARD);                   
            delay(1000);                         
            mySCMD.moveMotors (STOP);                   
            mySCMD.moveMotors (RIGHT);                   
            delay(1000);                         
            mySCMD.moveMotors (STOP);                   

}



