/*
 * config.h
 *
 *  Created on: 26 may. 2018
 *      Author: Javier Artacho Garcia
 */

#ifndef CONFIGHARDWARE_H_
#define CONFIGHARDWARE_H_

// definition of pins used by the distance sensor HCSR04
#define trigPin 38 //pin where the trigger for the distance sensor is attached
#define echoPin 37  //pin where the echo from the distance sensor is attached

// definition of constants used by the SCMD driver
#define FORWARD 1    //definition of constant FORWARD=1
#define BACKWARD 2  //definition of constant BACKWARD=2
#define RIGHT 3     //definition of constant RIGHT=3
#define LEFT 4      //definition of constant LEFT=4
#define STOP 0      //definition of constant STOP=0
#define addressI2C 0x59  //address I2C associated to the SCMD

// definition of pins for LEDs
#define onLED 75  //LED that indicates if the robot is scanning
#define leftContLED 39  //LED that indicates a left contact
#define rightContLED 40   //LED that indicates a right contact

//definition of pins for the contact sensors
#define leftContactPIN 39 //left contact sensor on pin P2.6
#define rightContactPIN 40 //right contact sensor on pin P2.7



#endif /* CONFIGHARDWARE_H_ */
